require 'sketchup'

def put_holes
	drd_file = UI.openpanel "Open .drd File", "", "*.drd"
	
	f_in = open(drd_file)
	
	model = Sketchup.active_model
	entities = model.active_entities
	vector = Geom::Vector3d.new 0,0,1
	vector2 = vector.normalize!
	
	stepNum = 0
	defines = Hash::new()
	dia = 0.0
	while line = f_in.gets
	
		if /^%$/ =~ line
			stepNum += 1
		end
		if stepNum == 1 then
			if /^(T\d+)C([0-9.]+)$/ =~ line
				defines[$1] = ($2.to_f / 2)
				
			end
		end
		
		if stepNum == 2 then
			if /^(T\d+)$/ =~ line then
				dia = defines[$1]
				puts dia
			end
			xNumStr = "0"
			yNumStr = "0"
			xNum = 0.0
			yNum = 0.0
			if /^X(\d*)(\d{4})Y(\d*)(\d{4})$/ =~ line then
				if $1.nil? || $1 == "" then
					xNumStr = "0"
				else
					xNumStr = $1.to_s
				end
				xNum =  (xNumStr + '.' + $2.to_s).to_f
				
				if $3.nil? || $3 == "" then
					yNumStr = "0"
				else
					yNumStr = $3
				end
				yNum = (yNumStr + '.' + $4.to_s).to_f
				
				centerpoint = Geom::Point3d.new xNum, yNum, 0
				edges = entities.add_circle centerpoint, vector2, dia
				entities.add_face(edges)
			end
		end
	  
	end
	f_in.close
end		#def put_holes

UI.menu("PlugIns").add_item("Put Holes") { put_holes }